import { useCallback as u, useState as m } from "react";
import { useEventCallback as w } from "./useEventCallback.js";
import { useEventListener as E } from "./useEventListener.js";
const s = "av-local-storage", h = (t) => {
  try {
    return JSON.stringify(t);
  } catch {
    throw new Error(
      "@versini/ui-hooks useLocalStorage: Failed to serialize the value"
    );
  }
}, p = (t) => {
  try {
    return t && JSON.parse(t);
  } catch {
    return t;
  }
};
function V({
  key: t,
  defaultValue: n,
  deserialize: g = p,
  serialize: c = (o) => h(o)
}) {
  const o = typeof n == "function" ? n() : n, a = u(() => {
    let r;
    try {
      r = typeof window > "u" || !("localStorage" in window) || window.localStorage === null;
    } catch {
      r = !0;
    }
    if (r)
      return window.localStorage.setItem(t, c(o)), o;
    try {
      const e = window.localStorage.getItem(t);
      return e !== null ? g(e) : (window.localStorage.setItem(t, c(o)), o);
    } catch (e) {
      return console.warn(`Error reading localStorage key “${t}”:`, e), o;
    }
  }, [o, t]), [l, i] = m(a()), S = w((r) => {
    try {
      const e = r instanceof Function ? r(l) : r;
      if (e === void 0)
        return;
      window.localStorage.setItem(t, c(e)), i(e), window.dispatchEvent(new Event(s));
    } catch (e) {
      console.warn(`Error setting localStorage key “${t}”:`, e);
    }
  }), d = w(() => (window.localStorage.removeItem(t), i(a()), window.dispatchEvent(new Event(s)), l)), f = u(
    (r) => {
      r != null && r.key && r.key !== t || i(a());
    },
    [t, a]
  );
  return E(s, f), [l, S, d];
}
export {
  V as useLocalStorage
};
